/// <summary> /// Implement this method as an external command for Revit. /// </summary> /// <param name="commandData">An object that is passed to the external application /// which contains data related to the command, /// such as the application object and active view.</param> /// <param name="message">A message that can be set by the external application /// which will be displayed if a failure or cancellation is returned by /// the external command.</param> /// <param name="elements">A set of elements to which the external application /// can add elements that are to be highlighted in case of failure or cancellation.</param> /// <returns>Return the status of the external command. /// A result of Succeeded means that the API external method functioned as expected. /// Cancelled can be used to signify that the user cancelled the external operation /// at some point. Failure should be returned if the application is unable to proceed with /// the operation.</returns> public Autodesk.Revit.UI.Result Execute(ExternalCommandData commandData, ref string message, Autodesk.Revit.DB.ElementSet elements) { // try to initialize necessary data to create framing FrameData data = FrameData.CreateInstance(commandData); // display UI for user's input using (CreateFrameForm framingForm = new CreateFrameForm(data)) { if (framingForm.ShowDialog() == DialogResult.OK) { // create framing FrameBuilder builder = new FrameBuilder(data); builder.CreateFraming(); } else { // cancel the command return Autodesk.Revit.UI.Result.Cancelled; } } return Autodesk.Revit.UI.Result.Succeeded; }
/// <summary> /// Implement this method as an external command for Revit. /// </summary> /// <param name="commandData">An object that is passed to the external application /// which contains data related to the command, /// such as the application object and active view.</param> /// <param name="message">A message that can be set by the external application /// which will be displayed if a failure or cancellation is returned by /// the external command.</param> /// <param name="elements">A set of elements to which the external application /// can add elements that are to be highlighted in case of failure or cancellation.</param> /// <returns>Return the status of the external command. /// A result of Succeeded means that the API external method functioned as expected. /// Cancelled can be used to signify that the user cancelled the external operation /// at some point. Failure should be returned if the application is unable to proceed with /// the operation.</returns> public Autodesk.Revit.UI.Result Execute(ExternalCommandData commandData, ref string message, Autodesk.Revit.DB.ElementSet elements) { // try to initialize necessary data to create framing FrameData data = FrameData.CreateInstance(commandData); // display UI for user's input using (CreateFrameForm framingForm = new CreateFrameForm(data)) { if (framingForm.ShowDialog() == DialogResult.OK) { // create framing FrameBuilder builder = new FrameBuilder(data); builder.CreateFraming(); } else { // cancel the command return(Autodesk.Revit.UI.Result.Cancelled); } } return(Autodesk.Revit.UI.Result.Succeeded); }